function moteMainTrigger::onEnterTrigger(%db,%trig,%pl)
{
	if(!$mote_active)
	{
		$mote_lock = 0;
		$mote_active = 1;
		$mote_startTime = getSimTime();
		mote_speedrunLoop(%pl);
		if(isObject(%cl = %pl.client))
			%cl.play2D(moteBellSound);
	}
}
function mote_createTrigger()
{
	if(isObject($moteTrigger))
		$moteTrigger.delete();
	$moteTrigger = %t = new Trigger()
	{
		datablock = moteMainTrigger;
		scale = "80 70 70";
		polyhedron = "-0.5 -0.5 -0.5 1 0 0 0 1 0 0 0 1";
		position = "-78.3 -14.2 35";
		rotation = "1 0 0 0";
	};
	missionCleanup.add(%t);
}
function mote_formatTime(%t)
{
	%ms = %t/10%100|0;
	%s = %t/1000|0;
	%m = %s/60|0;
	%s = %s-(%m*60);
	return %m @ "\t" @ (%s < 10 ? "0" : "") @ %s @ "\t" @ (%ms < 10 ? "0" : "") @ %ms;
}
function mote_speedrunLoop(%pl)
{
	cancel($mote_sched);
	if(!isObject(%pl))
		return;
	%time = getSimTime();
	%cl = %pl.client;
	
	if($mote_lock)			%t = $mote_finalTime;
	else if($mote_active)	%t = %time-$mote_startTime;
	else					%t = 0;
	
	%t_s = mote_formatTime(%t);
	%str = "<font:consolas:36>" @ getField(%t_s,0) @ ":" @ getField(%t_s,1) @ "<font:consolas:26>." @ getField(%t_s,2);
	
	if($mote_lock) 			%col = "ffffff";
	else if($mote_active) 	%col = "aaff55";
	else					%col = "55ff55";
	
	for(%i=0;%i<$TreasureChest::NumChests;%i++)
	{
		%hash = $TreasureChest::ChestHash[%i];
		if(%cl.foundTreasureChest_[%hash])
		{
			%cnt++;
		}
	}
	%tcol = "";
	for(%i=0;%i<%cnt;%i++)
	{
		if(%i == %cnt-1 && %time-%cl.foundLastTreasureTime < 500)
		{
			%char = "\xA4";
			%tcol = "<color:" @ rgbToHex(rgbGradient((%time-%cl.foundLastTreasureTime)/500,"1 1 0","1 0 0")) @ ">";
			
			%trsre = %trsre @ %tcol @ %char;
		}
		else if(%tcol !$= "\c0")
		{
			%tcol = "\c0";
			%trsre = %trsre @ %tcol @ "\x95";
		}
		else
		{
			%trsre = %trsre @ "\x95";
		}
	}
	%cnt = $TreasureChest::NumChests-%cnt;
	for(%i=0;%i<%cnt;%i++)
	{
		if(%tcol !$= "\c6")
		{
			%tcol = "\c6";
			%trsre = %trsre @ %tcol @ "\xB7";
		}
		else
		{
			%trsre = %trsre @ "\xB7";
		}
	}
	bottomPrint(%cl,"<br><br><font:consolas:25>" @ %trsre @ "<just:right><color:" @ %col @ ">" @ %str @ " <br><font:a:8><div:1>",5,0,0);
	$mote_sched = schedule(32,%pl,mote_speedrunLoop,%pl);
}


//package mote_speedrun
//{
//
//};
//activatePackage(mote_speedrun);
function fullReset(%cl)
{
	resetTreasureChests();
	$mote_active = 0;
	$mote_lock = 0;
	bottomPrint(%cl,"",1);
	if(!isObject($moteTrigger))
		mote_createTrigger();
	if(isObject(%cl))
	{
		%cl.instantRespawn();
	}
	_FrankenChest.disappear(-1);
}
function serverCmdReset(%cl)
{
	fullReset(%cl);
}
function serverCmdResetPB(%cl)
{
	$Pref::moteSpeedrun_bestTime = 599999;
}
function resetTreasureChests()
{
	%cnt = (%cg = clientGroup).getCount();
	while(%cnt-->=0)
	{
		%cl = %cg.getObject(%cnt);
		for(%i=0;%i<$TreasureChest::NumChests;%i++)
		{
			%hash = $TreasureChest::ChestHash[%i];
			%cl.removeTreasureChestHash(%hash);
		}
		%cl.treasureRoomCnt = 0;
		%cl.numFoundTreasureChests = 0;
	}
	
}
function fxDTSBrick::nameTreasureChest(%br,%name,%num,%cl)
{
	%br.treasureName = %name;
	if(%name $= "Treasure Room")
	{
		%cl.treasureRoomCnt++;
		%name = "Treasure Room " @ %cl.treasureRoomCnt;
	}
	centerPrint(%cl,"<br><br><br><br><br><font:impact:38><color:ffffff>YOU GOT A CHEST!<br><font:impact:24><color:ffff00>" @ %name @ "" @ (%num !$= "" ? " " @ %num : "") @ "",4);
}

function mote_speedrunEnd(%pl,%step)
{
	cancel($mote_schedB);
	if(!isObject(%cl = %pl.client))
		return;
	if(%step > 0)
	{
		%base = "<font:impact:40><color:ffffff>MotE Mansion Complete!<br><font:a:3><div:1>";
		if($mote_finalTime < $Pref::moteSpeedrun_bestTime)
		{
			%better = 1;
		}
		else
		{
			if($mote_finalTime-$Pref::moteSpeedrun_bestTime < 1000*30)
			{
				%ok = 1;
			}
		}
		if(%step > 1)
		{
			%t_s = mote_formatTime($mote_finalTime);
			%tstrc = "<font:impact:30>Final Time: <color:" @ (%ok ? "ffff00" : (%better ? "55ff55" : "ff4400")) @ ">" @ getField(%t_s,0) @ ":" @ getField(%t_s,1) @ "<font:impact:22>." @ getField(%t_s,2);
		}
	}
	if(%step == 0)
	{
		$mote_finalTime = getSimTime()-$mote_startTime;
		$mote_lock = 1;
		%cl.schedule(1500,play2D,moteFluteSound);
		%pl.schedule(1000,setWhiteOut,0.4);
		$mote_schedB = schedule(7000,%pl,mote_speedrunEnd,%pl,1);
	}
	else if(%step == 1)
	{
		%cl.play2D(moteKickBSound);
		centerPrint(%cl,%base,10);
		$mote_schedB = schedule(1000,%pl,mote_speedrunEnd,%pl,2);
	}
	else if(%step == 2)
	{
		%cl.play2D(moteKickASound);
		
		centerPrint(%cl,%base @ "<br>" @ %tstrc,10);
		$mote_schedB = schedule(1000,%pl,mote_speedrunEnd,%pl,3);
	}
	else if(%step >= 3)
	{
		if(%step == 4)
		{
			$Pref::moteSpeedrun_bestTime = $mote_finalTime;
		}
		%t_s = mote_formatTime($Pref::moteSpeedrun_bestTime);
		%str = "" @ getField(%t_s,0) @ ":" @ getField(%t_s,1) @ "<font:impact:22>." @ getField(%t_s,2);
		%line = %base @ "<br>" @ %tstrc @ "<br><font:impact:24>\c6Personal Best: <color:55ff55>" @ %str;
		if(%step == 3)
		{
			if($mote_finalTime < $Pref::moteSpeedrun_bestTime)
			{
				%cl.play2D(moteCymbalBSound);
				$mote_schedB = schedule(300,%pl,mote_speedrunEnd,%pl,4);
			}
			else
			{
				%cl.play2D(moteCymbalASound);
			}
			centerPrint(%cl,%line,10);
		}
	}
	if(%step == 4)
	{
		centerPrint(%cl,%line @ "<br><br><font:impact:40>\c3New Record!!",10);
	}
}

if($Pref::moteSpeedrun_bestTime $= "")
	$Pref::moteSpeedrun_bestTime = 599999;
fullReset();